<?php
/**
 * Created by JetBrains PhpStorm.
 * User: jorgefonseca
 * Date: 20/07/13
 * Time: 13:37
 * To change this template use File | Settings | File Templates.
 */

namespace Folha\Logic;

use Folha\Logic\Cadastros\Parametros;
use Folha\Logic\Cadastros\Estrutura;
use Folha\Logic\Cadastros\ParceiroNegocio;
use Folha\Logic\Cadastros\Organizacao;
use Folha\Logic\Cadastros\Empresa;
use Folha\Logic\Cadastros\Filial;
use Folha\Logic\Cadastros\Operador;

class Cadastros {

    public static function estruturaCompleta(
        $nrorg, $nrtipoestrutura, $dtinivigencia, $dtmescompetenc, $cdsindical, $dtbasesindical, $cdnatujuri,
        $nmrazsocestrut, $nmestrutura, $nmfantasia, $cdcnpjestrut, $idtipoempr, $idoptsimples, $idparticipat, $nrcalendario,
        $cdcnae, $cdfpas, $cdtipoinscricao = 'LIVRE', $nrinscricaoparc = null, $cdpais, $sgestado, $cdmunicipio,
        $cdlogradouro, $nmbairroendereco, $cdtipoendereco = 'PRINCIPAL', $nrcependereco, $dscompleendereco, $nrimovelendereco, $dsendereco,
        $dsreferenciaende, $cdformacomu, $cdprefixcomuparc,$cdcomunicaparc, $nrparamferiasm,
        $nrparamfolham, $cdreducont, $cdbanco, $cdagencia, $cdcontcorr, $nrtpcontcorr)
    {
        $connection = \Setforms2\Shared\Registry::getEntityManagerConnection();
        $connection->beginTransaction();

        try {
            //@todo Colocar no strategy
            $idativo = 'S';
            $cdtipoparceiro = 'ESTRUTURA';
            $idpessoafisica = 'N';
            $idinstituicao  = 'S';

            $parcnegocio = new ParceiroNegocio($nrorg);
            $parcnegocio->novo(
                $nmrazsocestrut, $nmfantasia, $cdtipoparceiro, 'N', 'S', $cdtipoinscricao,
                $nrinscricaoparc, $dtinivigencia
            );

            $estrutura = new Estrutura($nrorg);
            $estrutura->nova(
                $nrtipoestrutura, null, $dtinivigencia, $dtmescompetenc, $parcnegocio->getParceiro()->getNrparcnegocio(),
                $cdsindical, $dtbasesindical, $cdnatujuri, $nmrazsocestrut, $nmestrutura, $nmfantasia, $cdcnpjestrut, $idtipoempr,
                $idoptsimples, $idparticipat, $nrcalendario, $cdcnae, $cdfpas
            );

            // $estrutura->novoMestre($nrtipoestrutura, $dtinivigencia, $cdintestrutura);

            // \Setforms2\Shared\Registry::getEntityManager()->flush();
            
            // $estrutura->novoHistorico(
            // $this->estruturam->getNrestruturam(), $dtmescompetenc, $nrtipoestrutura, $nrparcnegocio, $cdsindical,
            // $dtbasesindical, $cdnatujuri, $nmrazsocestrut, $nmfantasia, $cdcnpjestrut, $idtipoempr, $idoptsimples,
            // $idparticipat, $nrcalendario, $cdcnae, $cdfpas
            // );

            \Setforms2\Shared\Registry::getEntityManager()->flush();

            $endereco = new ParceiroNegocio\Endereco($nrorg);
            $endereco->novo(
                $parcnegocio->getParceiro()->getNrparcnegocio(), $cdpais, $sgestado, $cdmunicipio, $cdlogradouro,
                $nmbairroendereco, $cdtipoendereco, $nrcependereco, $dscompleendereco, $nrimovelendereco, $dsendereco,
                $dsreferenciaende
            );

            if ($cdcomunicaparc) {
                $comunicacao = new ParceiroNegocio\Comunicacao($nrorg);
                $comunicacao->novo(
                    $parcnegocio->getParceiro()->getNrparcnegocio(), $idativo, $cdcomunicaparc,
                    $cdprefixcomuparc, $cdformacomu
                );
            }

            if ($nrtpcontcorr) {
                $contacorrente = new ParceiroNegocio\Contacorrente($nrorg);
                $contacorrente->novo(
                    $parcnegocio->getParceiro()->getNrparcnegocio(), $cdreducont, $cdbanco,
                    $cdagencia, $cdcontcorr, $nrtpcontcorr
                );
            }

            if ($nrparamfolham) {
                $paramestrutura = new Parametros\Estrutura($nrorg);
                $paramestrutura->novo(
                    $estrutura->getEstruturam()->getNrestruturam(), $dtinivigencia, $dtmescompetenc, $nrparamferiasm,
                    $nrparamfolham
                );
            }

        } catch (\Exception $e) {
            tk_warning('Problema ao inserir cadastros.');
            $connection->rollBack();
            throw $e;
        }

        $connection->commit();
    }

    public static function organizacao($idativo,$nrinscricaoorg,$idtipoinscrorg,$nmrazsocialorg,$nmorganizacao,
                                       $dsurlmercadum,$cdsenhacadoper,$idpadunidmedorg,$idvalidcadastro,$dtvalidcadastro,$dsvalidcadastro,
                                       $cdoperinclusao,$nrorgultatu,$cdoperultatu,$nmacesso,$nrorg,$cdoperador,$cdfunc,$nmbairoper,
                                       $nrramaloper,$idligextoper,$idsenhvardia,$dsemailoper,$idopermaster,$idoperacesso,$cdsenemailop,
                                       $idoperativo,$cdsetor,$idfuninioper,$hriniageoper,$hrfimageoper,$cdcargo,$dtultatusenh,$idtpoperador,
                                       $idstatusenha,$dtultacesoper,$nrcelularoper,$idatuoperador,$cdbancoper,$cdagenoper,$cdccoroper,
                                       $cdoperesplibsen,$nrorg,$dtultatu,$nrorginclusao,$cdoperinclusao,$nrorgultatu,$cdoperultatu,
                                       $nrparcnegocio,$nrcepoper,$nrteleoper,$cdsenhoper,$cdcliente,$cdpais,$sgestado,$cdmunicipio,$nmoperador,
                                       $nmacesso,$nmcomploper,$dtnascimento,$dsendeoper,$nroperrede,$cdempresa,$cdsenhaoperweb,
                                       $nrperfilselecionado,$cdfilialselecionada,$nrorgselecionada,$cdprochablanope,$cdprochabaprope,
                                       $cdprochabfecope,$dtinclusao,$dtultatuoper){

        try {

            //@todo verificar de onde vem estes parametros
            $cdtipoparceiro = 'OPERADOR';
            $idpessoafisica = 'N';
            $idinstituicao  = 'S';
            $cdtipoinscricao  = 'LIVRE';
            $nrinscricaoparc  = 'SN-00000000000000001';
            $dtinivigencia  = '19/08/2013';
            $cdempresa = '01';
            $cdpais = '0055';
            $sgestado = 'MG';
            $cdmunicipio = '4123';
            $nrinsjurempr = 'ISENTA';
            $idnatuoperempr = '99';
            $idregesptribemp = '99';
            $cdinscesta = 'ISENTA';
            $idtpijuriest = 'I';
            $nrinsjuriest = 'ISENTA';
            $dsendeiest = 'D';
            $nmbairiest = 'D';
            $nrcepiest = '20';
            $idtpimpresdanfe = '1';
            $idtpambientenfe = '2';
            $idapurlucpre = 'N';
            $idutserecfnf = 'N';
            $idutnrcupomnf = 'N';
            $cdinscmuni = 'ISENTA';
            $idambtrabnfse = '2';
            $cdfilial = null; //@todo verificar qual será o parametro;
            $idutfilipadr = 'S';
            $idcomparqxmlfil = 'S';
            $idconsorcfil = 'N';

            //organizacao
            $organizacao = new Organizacao();
            $organizacao->novaOrganizacao($nrinscricaoorg,$idtipoinscrorg,$nmrazsocialorg,$nmorganizacao,$dsurlmercadum,
                $cdsenhacadoper,$idpadunidmedorg,$idvalidcadastro,$dtvalidcadastro,$dsvalidcadastro,$idativo,$dtinclusao,
                $dtultatu,$nrorginclusao,$cdoperinclusao,$nrorgultatu,$cdoperultatu,$nmacesso,$nrorg);

            $parcnegocio = new ParceiroNegocio();
            $parcnegocio->novo($nrorg, $idativo, $nmrazsocialorg, $nmrazsocialorg, $cdtipoparceiro,
                $idpessoafisica, $idinstituicao,$cdtipoinscricao, $nrinscricaoparc,$dtinivigencia);

            $nrparcnegocio = \Windows\OperadorWzdGpeWndOperadorWzd\GpeTabOperadorWzd\Facade::getParcnegocio();


            //empresa
            $empresa = new Empresa();
            $empresa->novaEmpresa($cdempresa,$cdpais,$sgestado,$cdmunicipio,$cdcentcust,$nmrazsocialorg,$nmrazsocialorg,
                $dsendeempr,$nmbairempr,$nrcepempr,$idtpijurempr, $nrinsjurempr,$nrinscesta,$nrregjuncom,$dtregjuncom,$nmcontempr,
                $nrcrccont,$nmtituempr,$cdempriest,$cdinscesta,$cdempimun,$cdinscmuni,$vrpemulempr,$vrmultaempr,$vrpemorempr,
                $vrmordiaempr,$cdnatujuri,$cdcontador2,$cdfpas,$cdcnae,$nrtelefoempr,$dslogradempr,$nrlogradempr,$dscmplogempr,
                $idparticipat,$idtipoempr,$idoptsimples,$nrpropriempr,$medatabase,$nrcaged,$cdemprcaixa,$vrpetxadmpor,$dtultatuempr,
                $dsarqrecibo,$dsarqrecirec,$cdbairro,$vrpecovenemp,$cdregimeapur,$nmcomprzsemp,$dscompendemp,$dsemailempresa,
                $dsendwebempr,$dsarqlogoemp,$dsmensemailnfe,$nrorg,$dtinclusao,$dtultatu,$nrorginclusao,$cdoperinclusao,$nrorgultatu,
                $cdoperultatu,$idnatuoperempr,$idregesptribemp,$cdsimplesnacional,$dsmensemailcce,$nrfinaidf,$nriniaidf,$qtnotasaidf,
                $dtemisaidf,$dtvalaidf,$nraidf,$nrregiespecial);

            $empresa->inscricaoEstadual($idapurlucpre,$cdfilial,$nmreprinsest,$idtpijuriest,$nrinsjuriest,$cdpais,
                $sgestado,$cdmunicipio,$dsendeiest,$nmbairiest,$nrcepiest,$nrteleiest,$nrfaxiest,$cdcstdig1sai,
                $dtultatuiest,$cdoperinclusao,$nrorgultatu,$cdoperultatu,$cdbairro,$dscompendies,$nrseriecertific,
                $idtpimpresdanfe,$idtpambientenfe,$cdcontador2,$dtinclusao,$dtultatu,$nrorginclusao,$idutserecfnf,
                $idutnrcupomnf,$cdempresa,$cdinscesta,$nrorg);

            $empresa->inscricaoMunicipal($cdoperultatu,$nrorginclusao,$cdoperinclusao,$nrorgultatu,$cdfilial,
                $nmreprinsmun,$dtultatuimun,$nrcertdignfse,$idambtrabnfse,$cdpais,$sgestado,$cdmunicipio,
                $cdbairro,$dsendeimun,$numinscmun,$dscompimun,$nrcepimun,$nrteleimun,$nrfaximun,$nrdddtelimun,
                $nrdddfaximun,$dtinclusao,$dtultatu,$nrinsjurimuni,$cdempresa,$cdinscmuni,$nrorg);

            //filial
            $filial = new Filial();
            $filial->novaFilial($nrinscricaoorg,$nmrazsocialorg,$nrinsjurfili,$cdfilifisc,$cdempresa,$cdinscmuni,
                $cdinscesta,$idtpijurfili,$idcntrresc,$nmrazsocfili,$cdtpcontrato,$cdtpcliente,$cdregiao,$cdgoperac,
                $cdsupervisor,$cdadministra,$cdareagere,$cdcontctbl,$idendemisfil,$idendcfopfil,$cdserie,$cdfilcentcmp,
                $dtultatufili,$cdsegmer,$cdgrupofisc,$cdempresap,$cdcentcust,$idutfilipadr,$dtincontrfil,$dtficontrfil,
                $idfuncaofili,$vrpecovenfil,$cdfilcentpme,$idfilcentpme,$nmcomprzsfil,$vrpecreprest,$cdeanfilial,
                $qtfuncfili,$cdfornopelog,$dtinicialbi,$cdreducont,$nrinscsuframafi,$dtiniutilizanfe,$nrmesreajcontr,
                $cdprecobase,$idcomparqxmlfil,$idconsorcfil,$vrpeorcbloqfil,$vrpeorcalertfil,$nrorg,$dtinclusao,$dtultatu,
                $nrorginclusao,$cdoperinclusao,$nrorgultatu,$cdoperultatu,$nrparcnegocio,$idcumupiscofil,$cdfilialext);

            //operador
            $operador = new Operador();
            $operador->novoOperador($cdoperador,$cdfunc,$nmbairoper,$nrramaloper,$idligextoper,$idsenhvardia,$dsemailoper,
                $idopermaster,$idoperacesso,$cdsenemailop,$idoperativo,$cdsetor,$idfuninioper,$hriniageoper,
                $hrfimageoper,$cdcargo,$dtultatusenh,$idtpoperador,$idstatusenha,$dtultacesoper,$nrcelularoper,
                $idatuoperador,$cdbancoper,$cdagenoper,$cdccoroper,$cdoperesplibsen,$nrorg,$dtultatu,$nrorginclusao,
                $cdoperinclusao,$nrorgultatu,$cdoperultatu,$nrparcnegocio,$nrcepoper,$nrteleoper,$cdsenhoper,
                $cdcliente,$cdpais,$sgestado,$cdmunicipio,$nmoperador,$nmacesso,$nmcomploper,$dtnascimento,
                $dsendeoper,$nroperrede,$cdempresa,$cdsenhaoperweb,$nrperfilselecionado,$cdfilialselecionada,
                $nrorgselecionada,$cdprochablanope,$cdprochabaprope,$cdprochabfecope,$dtinclusao,$dtultatuoper);

//            $operador->filiOper($cdoperador,$cdfilial,$idexibaviso,$dtultatufope,$nrorg,$dtinclusao,
//                $dtultatu,$nrorginclusao,$cdoperinclusao,$nrorgultatu,$cdoperultatu,$nrorgfilial);
//
//            $operador->gpeParamOper($cdoperador,$nrorg,$dtmescompetenc,$idtpdtcompete,$dtinclusao,
//                $dtultatu,$nrorginclusao,$cdoperinclusao,$nrorgultatu,$cdoperultatu,$idambientesal,$nrorgtrab,
//                $iddebug,$nrtpmodalidsal,$nrtpmodalidcal,$nrocorrecal,$nrestruttrab);
//
//            $operador->gpeOrgRelOper($nrorg,$nrorgreloper,$nrestruturam,$nrorgoper,$cdoperador,
//                $dtinclusao,$dtultatu,$nrorginclusao,$cdoperinclusao,$nrorgultatu,$cdoperultatu);
//
//            //@todo verificar
//            $organizacao->gpeParamOrg($dtcompetencia,$nrorg,$dtinclusao,$dtultatu,$nrorginclusao,$cdoperinclusao,
//                $nrorgultatu,$cdoperultatu,$nrorgpadrao,$nrtpestrutlegal,$nrtpestrutgeren);


            $msg = 'Cadastrado com sucesso.';
            tk_message($msg, 'success', 5000);
            tk_close_wizard('gpe_estrutura_wzd');

        } catch (\Exception $e) {

            $error = 'Ops! Não foi possível cadastrar, informe ao administrador o seguinte erro: ' . $e->getMessage();
            tk_message($error, 'warning');

        }

    }

}