/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_FATORPRECO                                               */
/* Tabela : FATORPRECO                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 30/03/2004 - WELBERT G. MOITINHA                                           */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_FATORPRECO
BEFORE INSERT OR UPDATE OR DELETE
ON FATORPRECO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUFPRE := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDFATPRECO,0) <> NVL(:NEW.CDFATPRECO,0)) OR
         (NVL(:OLD.SGFATPRECO,0) <> NVL(:NEW.SGFATPRECO,0)) OR
         (NVL(:OLD.NMFATPRECO,0) <> NVL(:NEW.NMFATPRECO,0)) THEN
         :NEW.DTULTATUFPRE := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('FATORPRECO','', 'CDFATPRECO='||:OLD.CDFATPRECO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE FATORPRECO MODIFY DTULTATUFPRE DEFAULT SYSDATE
/
