create or replace PROCEDURE DIST_AUTO_PROD
(
   P_NRDISTPROD IN DISTPROD.NRDISTPROD%TYPE,
   P_NRPRODDISTPROD IN PRODDISTPROD.NRPRODDISTPROD%TYPE,
   P_CDPRODUTO IN PRODUTO.CDPRODUTO%TYPE, 
   P_QTCOMENSAIS IN NUMBER,
   P_QTPRODUTO IN NUMBER,
   P_IDTIPO IN VARCHAR2 DEFAULT 'N' /*POR DEFAULT DISTRIBUI NAO RECURSIVO*/ 
)
IS
V_CDCONTAINER VARCHAR2(5);
V_VRQTDEPRODEMB NUMBER;
V_PONTUACAO NUMBER;
V_QTPRODUTO NUMBER;
V_QTCONTAINER NUMBER;
V_NREMBDISTPROD NUMBER;
V_SEQUENCIAL VARCHAR2(20);
BEGIN

   /*CALCULA A DISTRIBUICAO DE MODO NAO RECURSIVO. VAI SEMPRE NA MESMA EMBALAGEM*/
   IF P_IDTIPO = 'N' THEN 
      /*RETORNA O CONTAINER DE MENOR PONTUACAO, OU SEJA, AQUELE QUE UTILIZA MENOS EMBALAGENS E QUE TEM MAIOR PERCENTUAL DE OCUPACAO  */
      SELECT CDCONTAINER, VRQTDEPRODEMB, PONTUACAO 
        INTO V_CDCONTAINER, V_VRQTDEPRODEMB, V_PONTUACAO
       FROM(SELECT A.CDCONTAINER, VRQTDEPRODEMB, MIN(A.QTEMBCOMPLETAS + A.QTNAOAPROVEITAMENTO) AS PONTUACAO 
              FROM(SELECT CDCONTAINER, CASE TRUNC(P_QTPRODUTO / VRQTDEPRODEMB) WHEN 0 THEN 1 ELSE TRUNC(P_QTPRODUTO / VRQTDEPRODEMB) END AS QTEMBCOMPLETAS,
                          VRQTDEPRODEMB, CASE MOD(P_QTPRODUTO , VRQTDEPRODEMB) 
                                         WHEN 0 THEN 0 ELSE (1 - ((VRQTDEPRODEMB - MOD(P_QTPRODUTO , VRQTDEPRODEMB)) / VRQTDEPRODEMB)) END AS QTNAOAPROVEITAMENTO
                     FROM RELPRODEMB
                    WHERE CDPRODUTO = P_CDPRODUTO) A
              GROUP BY A.CDCONTAINER,VRQTDEPRODEMB
              ORDER BY MIN(A.QTEMBCOMPLETAS + A.QTNAOAPROVEITAMENTO))
      WHERE ROWNUM = 1;
            
      DBMS_OUTPUT.PUT_LINE('CONTAINER ' || V_CDCONTAINER ||' PRODUTO ' || P_CDPRODUTO);     
      V_QTCONTAINER := TRUNC(P_QTPRODUTO/V_VRQTDEPRODEMB);
      IF MOD(P_QTPRODUTO, V_VRQTDEPRODEMB) <> 0 THEN
         V_QTCONTAINER := V_QTCONTAINER + 1;
      END IF;
      
      /*Busca novo sequencial*/               
      NOVO_CODIGO_SC('EMBDISTPROD',V_SEQUENCIAL);
      V_NREMBDISTPROD := TO_NUMBER(V_SEQUENCIAL);
   
      /*Insere embalagem na distribuio do cardpio*/
      INSERT INTO EMBDISTPROD
      (NREMBDISTPROD, NRDISTPROD, CDCONTAINER, QTCONTAINER)
      VALUES
      (V_NREMBDISTPROD, P_NRDISTPROD, V_CDCONTAINER, V_QTCONTAINER);  
      
      /*Insere o prato na embalagem na distribuio*/
      INSERT INTO ITEMBDISTPROD
      (NRPRODDISTPROD, NREMBDISTPROD, NRDISTPROD, 
       QTCOMENSAIS, QTPRODUTO, IDPRINCIPAL)
      VALUES
      (P_NRPRODDISTPROD, V_NREMBDISTPROD, P_NRDISTPROD, 
       P_QTCOMENSAIS, P_QTPRODUTO, 'S');
   
   END IF;

END;
/

-- VERSAO --
BEGIN ATUVEROBJ('DIST_AUTO_PROD','6.05.000'); END;
/
