import { Http, IEventParam, Metadata } from '@zeedhi/core';
import {
  AlertService, Form, Modal, ModalService,
} from '@zeedhi/common';
import { ZdGrid } from '@zeedhi/vuetify';

export class Dfs48000SaidaDoOperadorLogisticoController {
  private FiltroSaidaOplModal!: Modal;

  private ModalGerarDocumento!: Modal;
  
  public readOnlySubGrup: boolean = true;

  public readOnlyRota: boolean = true;

  public readOnlyDestPed: boolean = true;

  public readOnlyLote: boolean = true;

  public filterValueCDFILIOPELOG: any = null;
  
  public filterValueCDROTATRANS: Array<any> = [];

  public filterValueCDSUBGRPPROD: Array<any> = [];

  public filterValueCDFILIALDEST: Array<any> = [];

  public filterValueCDLOTENVIOL: Array<any> = [];

  public filterValuePEDOLEXTR: any = 'Extra';

  public filterValueNRSJUREMPR: any = 'Desconsidera';

  public filterValueDTENTREGA : string = '';

  public filterValueSTATUS : Array<any> = [];

  public filterValueDATAENT : any = 'Data de Entrega';

  public filterGridFormulario: any = {};

  public filterGridFormularioProduto: any = {};

  public filterGridLancamentoGerado: any = {};

  public paraSupri: any = {};

  public async createFiltroSaidaOplModal() {
    this.FiltroSaidaOplModal = await ModalService.createFromJson('pages/dfs48000/dfs4800Saida_do_opl_filtro', true);

    this.ModalGerarDocumento = await ModalService.createFromJson('pages/dfs48000/dfs4800Saida_do_opl_gerar_documento', true);

    this.FiltroSaidaOplModal.show();

    Http.get('/crudN/parasupri?in=CDFILIAL&CDFILIAL=FILIAL_LOGADA').then((response) => {
      this.paraSupri = response.data.data[0];
    });
  }

  public destroyFiltroSaidaOplModal() {
    this.FiltroSaidaOplModal?.destroy();
  }

  public async abrirFiltroSaidaOplModal() {
    this.FiltroSaidaOplModal.show();
  }

  public fecharFiltroSaidaOplModal() {
    this.FiltroSaidaOplModal.hide();
  }

  public confirmarFiltro() {
    const form = Metadata.getInstance<Form>('formFiltroSaidaOpl');
    const valid = form.validate();

    if (!valid) {
      AlertService.show({
        top: true,
        right: true,
        timeout: 2000,
        name: 'filtroInvalidoAltert',
        text: 'Preencha todos os campos obrigatĂ³rios!',
        color: 'error',
      });
    } else {
      form.submit();

      this.loadGrid();

      this.fecharFiltroSaidaOplModal();
    }
  }

  public onChangeSwitchRota({ component }: IEventParam<any>) {
    if (this.readOnlyRota) {
      this.filterValueCDROTATRANS = [];
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'CDROTATRANS') {
          child.value = [];
        }
      });
    }
  }

  public onChangeSwitchSubGrup({ component }: IEventParam<any>) {
    if (this.readOnlySubGrup) {
      this.filterValueCDSUBGRPPROD = [];
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'CDSUBGRPROD') {
          child.value = [];
        }
      });
    }
  }

  public onChangeSwitchDestPed({ component }: IEventParam<any>) {
    if (this.readOnlyDestPed) {
      this.filterValueCDFILIALDEST = [];
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'CDFILIALDEST') {
          child.value = [];
        }
      });
    }
  }

  public onChangeSwitchLote({ component }: IEventParam<any>) {
    if (this.readOnlyLote) {
      this.filterValueCDLOTENVIOL = [];
      component.parent.children.forEach((child: { name: any; value: any; }) => {
        if (child.name === 'CDLOTENVIOL') {
          child.value = [];
        }
      });
    }
  }

  public onChangeFieldsFiltroOPL({ component }: IEventParam<any>) {
    switch (component.name) {
      case 'CDFILIOPELOG': {
        this.filterValueCDFILIOPELOG = component.value;
        break;
      }
      case 'CDROTATRANS': {
        this.filterValueCDROTATRANS = component.value;
        break;
      }
      case 'CDSUBGRPROD': {
        this.filterValueCDSUBGRPPROD = component.value;
        break;
      }
      case 'CDFILIALDEST': {
        this.filterValueCDFILIALDEST = component.value;
        break;
      }
      case 'CDLOTENVIOL': {
        this.filterValueCDLOTENVIOL = component.value;
        break;
      }
      case 'PEDOLEXTR': {
        this.filterValuePEDOLEXTR = component.value;
        break;
      }
      case 'DTENTREGA': {
        this.filterValueDTENTREGA = component.value;
        break;
      }
      case 'STATUS': {
        this.filterValueSTATUS = component.value;
        break;
      }
      case 'NRSJUREMPR': {
        this.filterValueNRSJUREMPR = component.value;
        break;
      }
      case 'DATAENT': {
        this.filterValueDATAENT = component.value;
        break;
      }
      default: break;
    }
  }

  public onFilterSaidaOpen({ component }: IEventParam<any>) {
    const fieldCDFILIOPELOG = component.getChildInstance('CDFILIOPELOG');
    const fieldCDROTATRANS = component.getChildInstance('CDROTATRANS');
    const fieldCDSUBGRPROD = component.getChildInstance('CDSUBGRPROD');
    const fieldCDFILIALDEST = component.getChildInstance('CDFILIALDEST');
    // const fieldCDLOTENVIOL = component.getChildInstance('CDLOTENVIOL');
    // const fieldPEDOLEXTR = component.getChildInstance('PEDOLEXTR');
    // const fieldSTATUS = component.getChildInstance('STATUS');
    // const fieldNRSJUREMPR = component.getChildInstance('NRSJUREMPR');
    // const fieldDATAENT = component.getChildInstance('DATAENT');
    // const fieldDTENTREGA = component.getChildInstance('DTENTREGA');

    fieldCDFILIOPELOG.setValue(this.filterValueCDFILIOPELOG != null ? this.filterValueCDFILIOPELOG.CDFILIAL : null);
        
    const cdrotas: any[] = [];
    const cdsubgrpprods: any[] = [];
    const cdfiliais: any[] = [];
    // const cdloteenv: any[] = [];

    this.filterValueCDROTATRANS.forEach((val) => {
      if (fieldCDROTATRANS.value.indexOf(val.CDROTATRANS) === -1) {
        cdrotas.push(val.CDROTATRANS);
      }
    });

    fieldCDROTATRANS.setValue(cdrotas.length > 0 ? cdrotas : []);

    this.filterValueCDSUBGRPPROD.forEach((val) => {
      if (fieldCDSUBGRPROD.value.indexOf(val.CDSUBGRPROD) === -1) {
        cdsubgrpprods.push(val.CDSUBGRPROD);
      }
    });

    fieldCDSUBGRPROD.setValue(cdsubgrpprods.length > 0 ? cdsubgrpprods : []);

    this.filterValueCDFILIALDEST.forEach((val) => {
      if (fieldCDFILIALDEST.value.indexOf(val.CDFILIALDEST) === -1) {
        cdfiliais.push(val.CDFILIALDEST);
      }
    });

    fieldCDFILIALDEST.setValue(cdfiliais.length > 0 ? cdfiliais : []);

    // this.filterValueCDLOTENVIOL.forEach((val) => {
    //   if (fieldCDLOTENVIOL.value.indexOf(val.CDLOTENVIOL) === -1) {
    //     cdloteenv.push(val.CDLOTENVIOL);
    //   }
    // });

    // fieldCDLOTENVIOL.setValue(cdloteenv.length > 0 ? cdloteenv : []);
  }

  public loadGrid() {
    const grid = Metadata.getInstance<ZdGrid>('gridSaidasOPL');
    const arrayCDFILIAL: Array<any> = [];
    const arrayCDSUBGRPPROD: Array<any> = [];
    const arrayCDROTATRANS: Array<any> = [];
    // const arrayCDLOTENVIOL: Array<any> = [];
    // const fieldSTATUS = Metadata.getInstance<ZdGrid>('STATUS');
  
    let valueCDFILIAL: String = '';
    let valueCDSUBGRPPROD: String = '';
    let valueCDROTATRANS: String = '';
    // let valueCDLOTENVIOL: String = '';

    this.filterValueCDFILIALDEST.forEach((val) => {
      arrayCDFILIAL.push(val.CDFILIAL);
    });
    valueCDFILIAL = String('_').concat(arrayCDFILIAL.join('_').concat(String('_')));

    this.filterValueCDSUBGRPPROD.forEach((val) => {
      arrayCDSUBGRPPROD.push(val.CDSUBGRPROD);
    });
    valueCDSUBGRPPROD = String('_').concat(arrayCDSUBGRPPROD.join('_').concat(String('_')));

    this.filterValueCDROTATRANS.forEach((val) => {
      arrayCDROTATRANS.push(val.CDMARCA);
    });
    valueCDROTATRANS = String('_').concat(arrayCDROTATRANS.join('_').concat(String('_')));

    // this.filterValueCDLOTENVIOL.forEach((val) => {
    //   arrayCDLOTENVIOL.push(val.CDLOTENVIOL);
    // });
    // valueCDLOTENVIOL = String('_').concat(arrayCDLOTENVIOL.join('_').concat(String('_')));

    const newFilter = {
      P_CDFILIOPERLOG: this.filterValueCDFILIOPELOG.CDFILIAL,
      P_CDFILIAL: this.filterValueCDFILIALDEST.length > 0 ? valueCDFILIAL : 'T',
      P_CDSUBGRPPROD: this.filterValueCDSUBGRPPROD.length > 0 ? valueCDSUBGRPPROD : 'T',
      P_CDROTATRANS: this.filterValueCDROTATRANS.length > 0 ? valueCDROTATRANS : 'T',
      // P_CDLOTENVIOL: this.filterValueCDLOTENVIOL.length > 0 ? valueCDLOTENVIOL : 'T'
      
    };
    grid.datasource.filter = newFilter;
    grid.datasource.get();
  }

  public loadGridFormulario({ component }: any) {
    component.datasource.route = '/crudN/dfs48000_gridSaidaOplFormulario';

    component.datasource.filter = this.filterGridFormulario;
    component.datasource.get();
  }

  public loadGridFormularioProduto({ component }: any) {
    component.datasource.route = '/crudN/dfs48000_gridSaidaOplFormularioProduto';

    component.datasource.filter = this.filterGridFormularioProduto;
    component.datasource.get();
  }

  public loadGridLancamentoGerado({ component }: any) {
    component.datasource.route = '/crudN/dfs48000_gridSaidaOplLancamentoGerado';

    component.datasource.filter = this.filterGridLancamentoGerado;
    component.datasource.get();
  }

  // public onChangeCdfiliOl({ component }: IEventParam<any>) {
  //   const filialOplValue = Metadata.getInstance<ZdSelect>('CDFILIOPELOG');
  //   return filialOplValue.value.CDFILIOPELOG;
  // }
  
  public abrirModalGerarDocumento() {
    this.ModalGerarDocumento.show();
  }

  public fecharModalGerarDocumento() {
    this.ModalGerarDocumento.hide();
  }

  public async onModalGerarDocumentoAddOpen({ component }: IEventParam<any>) {
    const field = component.getChildInstance('CDFILIOPELOG');

    await field.setValue(this.filterValueCDFILIOPELOG.CDFILIAL);
  }

  public async salvarModalGerarDocumento() {
    const form = Metadata.getInstance<Form>('formModalGerarDocumentoAdd');
    const valid = form.validate();
    const arrayCDFILIAL: Array<any> = [];
    let valueCDFILIAL: String = '';

    if (form.value.CDFILIAL.length > 0) {
      form.value.CDFILIAL.forEach((val: any) => {
        arrayCDFILIAL.push(val.CDFILIAL);
      });
      valueCDFILIAL = String('_').concat(arrayCDFILIAL.join('_').concat(String('_')));
    } else {
      valueCDFILIAL = 'T';
    }

    if (!valid) {
      AlertService.show({
        top: true,
        right: true,
        timeout: 2000,
        name: 'invalidoAltert',
        text: 'Preencha todos os campos obrigatórios!',
        color: 'error',
      });
    } else {
      form.submit();

      const row = {
        CDFILIOPELOG: form.value.CDFILIOPELOG.CDFILIAL,
        CDFILDEST: valueCDFILIAL,
        CDTIPOOPER: form.value.CDTIPOOPER,
        DATA: form.value.DATA,
        NMRAZSOCTRAN: form.value.NMRAZSOCTRAN.NMRAZSOCTRAN,
        FRETE: form.value.FRETE.FRETE,
        NRPLACA: form.value.NRPLACA.NRPLACA,
        SGUFVEICULO: form.value.SGUFVEICULO.SGUFVEICULO,
      };

      await Http.post('/', { requestType: 'Row', row }).then((response) => {
        if (response.data.error !== undefined) {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Por favor entre em contato com o Suporte Teknisa!',
            color: 'error',
          });
        } else if (response.data.dataset.data.P_ERROS === 'N') {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'successAlert',
            text: 'Processo concluído com sucesso!',
            color: 'success',
          });

          this.fecharModalGerarDocumento();
        } else {
          AlertService.show({
            top: true,
            right: true,
            timeout: 2000,
            name: 'errorAlert',
            text: 'Não foi possível concluir o processo!<br>Não há dados!',
            color: 'error',
          });
        }
      });
    }
  }
}
